﻿Option Strict On
Imports Microsoft.Phone.Tasks
Imports System.IO.IsolatedStorage
Imports Microsoft.Xna.Framework.Media
Imports System.Windows.Media.Imaging
Imports System.Xml.Linq
Imports Microsoft.Expression.Interactivity.Layout
Public Class ImageFilter
    Public Property 画像名 As String
    Public Property fileName As String
End Class


Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim xmldoc As XElement
    Dim myScale As Double = 1
    Dim myWriteableBitmap As WriteableBitmap
    Dim createImage As Image
    Private Sub callImageButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles callImageButton.Click
        Dim photoTask As New PhotoChooserTask
        AddHandler photoTask.Completed, Sub(photoSender As Object, photoArgs As PhotoResult)
                                            If photoArgs.TaskResult = TaskResult.OK Then
                                                Dim bmp As New BitmapImage
                                                bmp.SetSource(photoArgs.ChosenPhoto)
                                                Image1.Source = bmp
                                            End If
                                        End Sub
        photoTask.Show()
    End Sub

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        xmldoc = XElement.Load("ImageFilter.xml")
        Dim myFilterImage As New List(Of ImageFilter)

        For Each result In From c In xmldoc.Descendants("画像名") Select c
            With myFilterImage
                .Add(New ImageFilter With {.画像名 = result.Value, .fileName = "Image/" & result.Attribute("fileName").Value})
            End With
        Next
        ListBox1.ItemsSource = myFilterImage
    End Sub

    Private Sub Slider1_ValueChanged(sender As Object, e As System.Windows.RoutedPropertyChangedEventArgs(Of Double)) Handles Slider1.ValueChanged
        Dim photoOriginalWidth As Double = CDbl(createImage.GetValue(FrameworkElement.ActualWidthProperty))

        myScale = (photoOriginalWidth + (Slider1.Value - 160)) / photoOriginalWidth

        Dim myScaleTransform As New ScaleTransform
        myScaleTransform.ScaleY = myScale
        myScaleTransform.ScaleX = myScale
        createImage.RenderTransform = myScaleTransform
    End Sub


    Private Sub clearButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles clearButton.Click
        InkPresenter1.Children.Clear()
        Slider1.Value = 160
    End Sub

    Private Sub ListBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged

        Dim myImage As String = xmldoc.Descendants("画像名")(ListBox1.SelectedIndex).Attribute("fileName").Value
        createImage = New Image
        With createImage
            .Width = 193
            .Height = 70
            .Source = New BitmapImage(New Uri("Image/" & myImage, UriKind.Relative))
        End With
        InkPresenter1.Children.Add(createImage)

        Slider1.IsEnabled = True


        Dim behaivior As New MouseDragElementBehavior
        behaivior.Attach(createImage)
    End Sub

    Private Sub saveButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles saveButton.Click
        Dim fileName As String = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"

        myWriteableBitmap = New WriteableBitmap(InkPresenter1, Nothing)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.FileExists(fileName) = True Then
            storage.DeleteFile(fileName)
        End If
        Using myStream As IsolatedStorageFileStream = storage.CreateFile(fileName)
            System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, myStream, myWriteableBitmap.PixelWidth, myWriteableBitmap.PixelHeight, 0, 85)
        End Using
        Dim myLibray As New MediaLibrary
        Using myStream As IsolatedStorageFileStream = storage.OpenFile(fileName, IO.FileMode.Open, IO.FileAccess.Read)
            myLibray.SavePicture(fileName, myStream)
            MessageBox.Show("PicturesHubに保存しました。")
        End Using
    End Sub
End Class
